#include "otabrowse5.h"
#pragma hdrstop

#include "component.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TComponentForm *ComponentForm;
//---------------------------------------------------------------------------
__fastcall TComponentForm::TComponentForm(TComponent* Owner)
        : TForm(Owner), c(NULL), fe(NULL)
{
}
void __fastcall TComponentForm::FormShow(TObject *Sender)
{ bRefreshProps->Click();
  bRefreshHierarchy->Click();
}
//---------------------------------------------------------------------------
void __fastcall TComponentForm::bRefreshPropsClick(TObject *Sender)
{ int old=lbProps->ItemIndex;
  lbProps->Items->BeginUpdate();
  lbProps->Items->Clear();
  for (int i=0; i<c->GetPropCount(); i++)
  { AnsiString prop=c->GetPropName(i);
    AnsiString val=GetComponentPropertyTextOTA(fe,c,prop);
    AnsiString kind=PropertyTypeToString(c->GetPropType(i));
    lbProps->Items->Add(prop+": "+val+" ("+kind+")");
  }
  lbProps->Items->EndUpdate();
  lbProps->ItemIndex=old;
}
//---------------------------------------------------------------------------
void __fastcall TComponentForm::bSetPropClick(TObject *Sender)
{ if (lbProps->ItemIndex==-1) {Application->MessageBox("First select a property; then you can set it","Set Property",MB_OK);return;}
  int i=lbProps->ItemIndex;
  AnsiString prop=c->GetPropName(i);
  AnsiString val=eSetProp->Text;
  SetComponentPropertyTextOTA(fe,c,prop,val);
  lbProps->Refresh();
}
//---------------------------------------------------------------------------
void __fastcall TComponentForm::bRefreshHierarchyClick(TObject *Sender)
{ Caption="Component - "+ComponentToString(fe,c);
  _di_IOTAComponent par=c->GetParent();
  if (par==NULL) eParent->Text="<none>"; else eParent->Text=ComponentToString(fe,par);
  AnsiString s=ComponentToString(fe,c); if (c->IsTControl()) s=s+" (a TControl)";
  eThis->Text=s;
  lbControls->Items->Clear(); lbOwns->Items->Clear();
  for (int i=0; i<c->GetControlCount(); i++) lbControls->Items->Add(ComponentToString(fe,c->GetControl(i)));
  for (int i=0; i<c->GetComponentCount(); i++) lbOwns->Items->Add(ComponentToString(fe,c->GetComponent(i)));
}
//---------------------------------------------------------------------------
void __fastcall TComponentForm::bSelectClick(TObject *Sender)
{ c->Select(xAddToSelection->Checked);
}
//---------------------------------------------------------------------------
void __fastcall TComponentForm::bFocusClick(TObject *Sender)
{ c->Focus(xAddToSelection->Checked);
}
//---------------------------------------------------------------------------
void __fastcall TComponentForm::bDeleteClick(TObject *Sender)
{ c->Delete(); ModalResult=mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TComponentForm::bSetBitmapClick(TObject *Sender)
{ if (c->GetComponentType()!="TImage") {Application->MessageBox("Setting bitmap has only been implemented for TImage components","Set Bitmap",MB_OK);return;}
  if (ExtractFileExt(CreateDialog1->FileName)!=".bmp") CreateDialog1->FileName="";
  CreateDialog1->DefaultExt="bmp";
  CreateDialog1->Filter="Bitmaps (*.bmp)|*.bmp";
  bool res=CreateDialog1->Execute();
  if (!res) return;
  AnsiString fn=CreateDialog1->FileName;
  SetComponentImageOTA(fe,c,fn,true);
  lbProps->Refresh();
}

//---------------------------------------------------------------------------

void __fastcall TComponentForm::bSetIconClick(TObject *Sender)
{ if (c->GetComponentType()!="TImage") {Application->MessageBox("Setting icon has only been implemented for TImage components","Set Icon",MB_OK);return;}
  if (ExtractFileExt(CreateDialog1->FileName)!=".ico") CreateDialog1->FileName="";
  CreateDialog1->DefaultExt="ico";
  CreateDialog1->Filter="Icons (*.ico)|*.ico";
  bool res=CreateDialog1->Execute();
  if (!res) return;
  AnsiString fn=CreateDialog1->FileName;
  SetComponentImageOTA(fe,c,fn,false);
  lbProps->Refresh();
}
//---------------------------------------------------------------------------

