#include "otabrowse5.h"
#pragma hdrstop

#include "moduleservices.h"
#include "module.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TModuleServicesForm *ModuleServicesForm;
//---------------------------------------------------------------------------
__fastcall TModuleServicesForm::TModuleServicesForm(TComponent* Owner) : TForm(Owner), ms(NULL)
{
}
void __fastcall TModuleServicesForm::FormShow(TObject *Sender)
{ // Modules page
  bRefresh->Click();
  _di_IOTAModule curm=ms->CurrentModule();
  if (curm!=NULL) eFindFormModule->Text=curm->GetFileName();
  if (curm!=NULL) eFindModule->Text=curm->GetFileName();
  // CreateModule page
  int i=cbCMCreatorType->Items->Count; if (i>1) i=1;
  cbCMCreatorType->Text=cbCMCreatorType->Items->Strings[i];
  cbCMOwner->Items->Clear();
  cbCMOwner->Items->Add("");
  for (int i=0; i<ms->GetModuleCount(); i++)
  { _di_IOTAProject p=NULL;
    HRESULT res=ms->Modules[i]->QueryInterface(__uuidof(IOTAProject),(void**)&p);
    if (SUCCEEDED(res)) cbCMOwner->Items->Add(ExtractFileName(p->GetFileName()));
  }
  i=cbCMOwner->Items->Count; if (i>1) i=1;
  cbCMOwner->Text=cbCMOwner->Items->Strings[i];
  // CreateProject page
  i=cbCPCreatorType->Items->Count; if (i>1) i=1;
  cbCPCreatorType->Text=cbCPCreatorType->Items->Strings[i];
  cbCPOwner->Items->Clear();
  cbCPOwner->Items->Add("");
  for (int i=0; i<ms->GetModuleCount(); i++)
  { _di_IOTAProjectGroup pg=NULL;
    HRESULT res=ms->Modules[i]->QueryInterface(__uuidof(IOTAProjectGroup),(void**)&pg);
    if (SUCCEEDED(res)) cbCPOwner->Items->Add(ExtractFileName(pg->GetFileName()));
  }
  i=cbCPOwner->Items->Count; if (i>1) i=1;
  cbCPOwner->Text=cbCPOwner->Items->Strings[i];
  // CreateProjectGroup page
  cbCGCreatorType->Text=""; cbCGOwner->Text="";
}
//---------------------------------------------------------------------------

void __fastcall TModuleServicesForm::bRefreshClick(TObject *Sender)
{ lbModules->Clear();
  int num=ms->GetModuleCount();
  //
  _di_IOTAModule curm=ms->CurrentModule();
  AnsiString curfn=""; if (curm!=NULL) curfn=curm->GetFileName();
  //
  for (int i=0; i<num; i++)
  { _di_IOTAModule m=ms->GetModule(i);
    AnsiString fn=m->GetFileName();
    bool cur = (fn==curfn);
    int modcount=m->GetModuleFileCount();
    AnsiString s=ExtractFileName(fn);
    if (cur) s=s+"* "; s=s+" - "+AnsiString(modcount)+" files";
    lbModules->Items->Add(s);
  }
}
//---------------------------------------------------------------------------

void __fastcall TModuleServicesForm::bNewModuleClick(TObject *Sender)
{ tNewModule->Caption = BoolToString(ms->NewModule());
}
//---------------------------------------------------------------------------

void __fastcall TModuleServicesForm::bSaveAllClick(TObject *Sender)
{ tSaveAll->Caption = BoolToString(ms->SaveAll());
}
//---------------------------------------------------------------------------

void __fastcall TModuleServicesForm::bCloseAllClick(TObject *Sender)
{ tCloseAll->Caption = BoolToString(ms->CloseAll());
}
//---------------------------------------------------------------------------

void __fastcall TModuleServicesForm::bFindFormModuleClick(TObject *Sender)
{ _di_IOTAModule m = ms->FindFormModule(eFindFormModule->Text);
  if (m==NULL) Application->MessageBox("Form module not found","Find Form Module",MB_OK);
  else
  { SelectModule(m);
    bGetModule->Click();
  }
}
//---------------------------------------------------------------------------

void __fastcall TModuleServicesForm::bFindModuleClick(TObject *Sender)
{ _di_IOTAModule m = ms->FindModule(eFindModule->Text);
  if (m==NULL) Application->MessageBox("Module not found","Find Module",MB_OK);
  else
  { SelectModule(m);
    bGetModule->Click();
  }
}

void __fastcall TModuleServicesForm::SelectModule(_di_IOTAModule m)
{ for (int i=0; i<ms->GetModuleCount(); i++)
  { if (m->GetFileName()==ms->GetModule(i)->GetFileName()) {lbModules->ItemIndex=i; return;}
  }
}
_di_IOTAModule __fastcall TModuleServicesForm::FileNameToModule(AnsiString fn)
{ for (int i=0; i<ms->GetModuleCount(); i++)
  { _di_IOTAModule m=ms->Modules[i];
    AnsiString s=m->GetFileName();
    if (s==fn || ExtractFileName(s)==fn || ChangeFileExt(ExtractFileName(s),"")==fn) return m;
  }
  return NULL;
}

//---------------------------------------------------------------------------

void __fastcall TModuleServicesForm::bGetNewModuleAndClassNameClick(
      TObject *Sender)
{ AnsiString prefix=eCMPrefix->Text;
  AnsiString filename="";
  AnsiString unitident="";
  AnsiString classname="";
  ms->GetNewModuleAndClassName(prefix,unitident,classname,filename);
  eCMFormName->Text=classname;
  eCMImplFileName->Text=filename;
}
//---------------------------------------------------------------------------

void __fastcall TModuleServicesForm::bGetModuleClick(TObject *Sender)
{ if (lbModules->ItemIndex==-1) return;
  _di_IOTAModule m=ms->GetModule(lbModules->ItemIndex);
  if (m==NULL) Application->MessageBox("Module not found","Get Module",MB_OK);
  else ShowModule(this,m);
}
//---------------------------------------------------------------------------

void __fastcall TModuleServicesForm::lbModulesDblClick(TObject *Sender)
{ bGetModule->Click();
}
//---------------------------------------------------------------------------


class TServicesModuleCreator : public IOTAModuleCreator
{
private:
  TModuleServicesForm *msf; long ref;
public:
  TServicesModuleCreator(TModuleServicesForm *f) : IOTAModuleCreator(), msf(f), ref(0) {}
  // IUnknown
  HRESULT STDMETHODCALLTYPE QueryInterface(REFIID riid, void **ppv) {if (riid==IID_IUnknown || riid==IID_IOTACreator || riid==IID_IOTAModuleCreator) {*ppv=this; AddRef(); return S_OK;} else return E_NOINTERFACE;}
  ULONG STDMETHODCALLTYPE AddRef() {return InterlockedIncrement(&ref);}
  ULONG STDMETHODCALLTYPE Release() {int tmp = InterlockedDecrement(&ref); if (tmp==0) delete this; return tmp;}
  // IOTACreator
  AnsiString __fastcall GetCreatorType() {return msf->cbCMCreatorType->Text;}
  bool __fastcall GetExisting() {return msf->xCMExisting->Checked;}
  AnsiString __fastcall GetFileSystem() {return msf->eCMFileSystem->Text;}
  _di_IOTAModule __fastcall GetOwner() {return msf->FileNameToModule(msf->cbCMOwner->Text);}
  bool __fastcall GetUnnamed() {return msf->xCMUnnamed->Checked;}
  // IOTAModuleCreator
  AnsiString __fastcall GetAncestorName() {return msf->eCMAncestorName->Text;}
  AnsiString __fastcall GetImplFileName() {return msf->eCMImplFileName->Text;}
  AnsiString __fastcall GetIntfFileName() {return msf->eCMIntfFileName->Text;}
  AnsiString __fastcall GetFormName() {return msf->eCMFormName->Text;}
  bool __fastcall GetMainForm() {return msf->xCMMainForm->Checked;}
  bool __fastcall GetShowForm() {return msf->xCMShowForm->Checked;}
  bool __fastcall GetShowSource() {return msf->xCMShowSource->Checked;}
  _di_IOTAFile __fastcall NewFormFile(const AnsiString FormIdent,const AnsiString AncestorIdent)
  { if (!msf->xCMUseForm->Checked) return NULL;
    TServicesFile *f=new TServicesFile(msf->eCMForm->Text); f->AddRef();
    _di_IOTAFile res=f; f->Release(); return res;
  }
  _di_IOTAFile __fastcall NewImplSource(const AnsiString ModuleIdent, const AnsiString FormIdent, const AnsiString AncestorIdent)
  { if (!msf->xCMUseImpl->Checked) return NULL;
    TServicesFile *f=new TServicesFile(msf->eCMImpl->Text); f->AddRef();
    _di_IOTAFile res=f; f->Release(); return res;
  }
  _di_IOTAFile __fastcall NewIntfSource(const AnsiString ModuleIdent, const AnsiString FormIdent, const AnsiString AncestorIdent)
  { if (!msf->xCMUseIntf->Checked) return NULL;
    TServicesFile *f=new TServicesFile(msf->eCMIntf->Text); f->AddRef();
    _di_IOTAFile res=f; f->Release(); return res;
  }
  void __fastcall FormCreated(const _di_IOTAFormEditor FormEditor) {}
};

void __fastcall TModuleServicesForm::bCMCreateModuleClick(TObject *Sender)
{ TServicesModuleCreator *smc=new TServicesModuleCreator(this); smc->AddRef();
  _di_IOTAModule m=ms->CreateModule(smc);
  smc->Release();
  ShowModule(this,m);
}
//---------------------------------------------------------------------------


class TServicesProjectCreator : public IOTAProjectCreator
{
private:
  TModuleServicesForm *msf; long ref;
public:
  TServicesProjectCreator(TModuleServicesForm *f) : IOTAProjectCreator(), msf(f), ref(0) {}
  // IUnknown
  HRESULT STDMETHODCALLTYPE QueryInterface(REFIID riid, void **ppv) {if (riid==IID_IUnknown || riid==IID_IOTACreator || riid==IID_IOTAProjectCreator) {*ppv=this; AddRef(); return S_OK;} else return E_NOINTERFACE;}
  ULONG STDMETHODCALLTYPE AddRef() {return InterlockedIncrement(&ref);}
  ULONG STDMETHODCALLTYPE Release() {int tmp = InterlockedDecrement(&ref); if (tmp==0) delete this; return tmp;}
  // IOTACreator
  AnsiString __fastcall GetCreatorType() {return msf->cbCPCreatorType->Text;}
  bool __fastcall GetExisting() {return msf->xCPExisting->Checked;}
  AnsiString __fastcall GetFileSystem() {return msf->eCPFileSystem->Text;}
  _di_IOTAModule __fastcall GetOwner() {return msf->FileNameToModule(msf->cbCPOwner->Text);}
  bool __fastcall GetUnnamed() {return msf->xCPUnnamed->Checked;}
  // IOTAProjectCreator
  AnsiString __fastcall GetFileName() {return msf->eCPFileName->Text;}
  AnsiString __fastcall GetOptionFileName() {return msf->eCPOptFileName->Text;}
  bool __fastcall GetShowSource() {return msf->xCPShowSource->Checked;}
  void __fastcall NewDefaultModule() {}
  _di_IOTAFile __fastcall NewOptionSource(const AnsiString ProjectName)
  { if (!msf->xCPUseOptionSource->Checked) return NULL;
    TServicesFile *f=new TServicesFile(msf->eCPOptionSource->Text); f->AddRef();
    _di_IOTAFile res=f; f->Release(); return res;
  }
  void __fastcall NewProjectResource(const _di_IOTAProject) {}
  _di_IOTAFile __fastcall NewProjectSource(const AnsiString ProjectName)
  { if (!msf->xCPUseSource->Checked) return NULL;
    TServicesFile *f=new TServicesFile(msf->eCPSource->Text); f->AddRef();
    _di_IOTAFile res=f; f->Release(); return res;
  }
};


void __fastcall TModuleServicesForm::bCPCreateModuleClick(TObject *Sender)
{ TServicesProjectCreator *spc=new TServicesProjectCreator(this); spc->AddRef();
  _di_IOTAModule m=ms->CreateModule(spc);
  spc->Release();
  ShowModule(this,m);
}
//---------------------------------------------------------------------------


class TServicesProjectGroupCreator : public IOTAProjectGroupCreator
{
private:
  TModuleServicesForm *msf; long ref;
public:
  TServicesProjectGroupCreator(TModuleServicesForm *f) : IOTAProjectGroupCreator(), msf(f), ref(0) {}
  // IUnknown
  HRESULT STDMETHODCALLTYPE QueryInterface(REFIID riid, void **ppv) {if (riid==IID_IUnknown || riid==IID_IOTACreator || riid==IID_IOTAProjectGroupCreator) {*ppv=this; AddRef(); return S_OK;} else return E_NOINTERFACE;}
  ULONG STDMETHODCALLTYPE AddRef() {return InterlockedIncrement(&ref);}
  ULONG STDMETHODCALLTYPE Release() {int tmp = InterlockedDecrement(&ref); if (tmp==0) delete this; return tmp;}
  // IOTACreator
  AnsiString __fastcall GetCreatorType() {return msf->cbCGCreatorType->Text;}
  bool __fastcall GetExisting() {return msf->xCPExisting->Checked;}
  AnsiString __fastcall GetFileSystem() {return msf->eCPFileSystem->Text;}
  _di_IOTAModule __fastcall GetOwner() {return msf->FileNameToModule(msf->cbCPOwner->Text);}
  bool __fastcall GetUnnamed() {return msf->xCPUnnamed->Checked;}
  // IOTAProjectGroupCreator
  AnsiString __fastcall GetFileName() {return msf->eCGFileName->Text;}
  bool __fastcall GetShowSource() {return msf->xCGShowSource->Checked;}
  _di_IOTAFile __fastcall NewProjectGroupSource(const AnsiString ProjectGroupName)
  { if (!msf->xCGUseSource->Checked) return NULL;
    TServicesFile *f=new TServicesFile(msf->eCGSource->Text); f->AddRef();
    _di_IOTAFile res=f; f->Release(); return res;
  }
};


void __fastcall TModuleServicesForm::bCGCreateModuleClick(TObject *Sender)
{ TServicesProjectGroupCreator *spgc=new TServicesProjectGroupCreator(this); spgc->AddRef();
  _di_IOTAModule m=ms->CreateModule(spgc);
  spgc->Release();
  ShowModule(this,m);
}
//---------------------------------------------------------------------------


void __fastcall TModuleServicesForm::bEnsureUniqueModuleClick(
      TObject *Sender)
{ AnsiString un=eEnsureUniqueUnit->Text;
  AnsiString fo=eEnsureUniqueForm->Text;
  AnsiString dir=eEnsureUniqueDir->Text;
  EnsureUniqueModuleName(&un,&fo,&dir);
  eEnsureUniqueUnit->Text=un;
  eEnsureUniqueForm->Text=fo;
  eEnsureUniqueDir->Text=dir;
}
//---------------------------------------------------------------------------

void __fastcall TModuleServicesForm::bLookForComponentClick(
      TObject *Sender)
{ AnsiString fn=eEnsureUniqueDir->Text+eEnsureUniqueUnit->Text;
  AnsiString fo=eEnsureUniqueForm->Text;
  AnsiString cname=eEnsureUniqueName->Text;
  AnsiString ctype=eEnsureUniqueType->Text;
  LookForComponent(NULL,&cname,&ctype,&fo,&fn);
  eEnsureUniqueDir->Text=ExtractFilePath(fn);
  eEnsureUniqueUnit->Text=ExtractFileName(fn);
  eEnsureUniqueForm->Text=fo;
  eEnsureUniqueName->Text=cname;
  eEnsureUniqueType->Text=ctype;

}
//---------------------------------------------------------------------------

