#include "otabrowse5.h"
#pragma hdrstop
USERES("otabrowse5.res");
USEPACKAGE("vcl50.bpi");
USEUNIT("toolsapiplus.cpp");
USEFORM("ideservices.cpp", IDEServicesForm);
USELIB("e:\borland\cbuilder5\Lib\usebormm.lib");
USEFORM("moduleservices.cpp", ModuleServicesForm);
USEFORM("module.cpp", ModuleForm);
USEFORM("moduleinfo.cpp", ModuleInfoForm);
USEFORM("editor.cpp", EditorForm);
USEFORM("resourceeditor.cpp", ResourceEditorForm);
USEFORM("resourceentry.cpp", ResourceEntryForm);
USEFORM("formeditor.cpp", FormEditorForm);
USEFORM("component.cpp", ComponentForm);
USEFORM("actionservices.cpp", ActionServicesForm);
USEFORM("services.cpp", ServicesForm);
USEFORM("notifier.cpp", NotifierForm);
USEFORM("packageservices.cpp", PackageServicesForm);
USEUNIT("sample.cpp");
USEFORM("watcherservices.cpp", WatcherServicesForm);
USEFORM("debuggerservices.cpp", DebuggerServicesForm);
USEFORM("ide.cpp", IDEForm);
USEFORM("projectoptions.cpp", ProjectOptionsForm);
USEFORM("messageservices.cpp", MessageServicesForm);
//---------------------------------------------------------------------------
#include "ideservices.h"
#include "watcherservices.h"
#include "module.h"
#include "moduleservices.h"
#include "moduleinfo.h"
#include "editor.h"
#include "resourceeditor.h"
#include "resourceentry.h"
#include "formeditor.h"
#include "component.h"
#include "actionservices.h"
#include "services.h"
#include "notifier.h"
#include "packageservices.h"
#include "debuggerservices.h"
#include "ide.h"
#include "projectoptions.h"
#include "messageservices.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*) {return 1;}
//---------------------------------------------------------------------------

class TOtaBrowseExpert : public IOTAMenuWizard
{
public:
  // IUnknown
  HRESULT STDMETHODCALLTYPE QueryInterface(REFIID riid, void **ppv) {if (riid==IID_IUnknown || riid==IID_IOTANotifier || riid==IID_IOTAWizard || riid==IID_IOTAMenuWizard) {*ppv=this; AddRef(); return S_OK;} else return E_NOINTERFACE;}
  ULONG STDMETHODCALLTYPE AddRef() {return InterlockedIncrement(&ref);}
  ULONG STDMETHODCALLTYPE Release() {int tmp = InterlockedDecrement(&ref); if (tmp==0) delete this; return tmp;}
  // IOTANotifier
  void __fastcall AfterSave() {}
  void __fastcall BeforeSave() {}
  void __fastcall Destroyed() {}   
  void __fastcall Modified() {}
  // IOTAWizard
  AnsiString __fastcall GetIDString() {return "WISCHIK.OTABROWSE5";}
  AnsiString __fastcall GetName() {return "OpenToolsAPI Browser";}
  TWizardState __fastcall GetState() {TWizardState ws; ws << wsEnabled; return ws;}
  void __fastcall Execute();
  // IOTAMenuWizard
  AnsiString __fastcall GetMenuText() {return "&OTA Browser...";}
  // TOtaBrowseExpert
  __fastcall TOtaBrowseExpert() : IOTAMenuWizard(), ref(0) {}
  __fastcall ~TOtaBrowseExpert() {}
private:
  long ref;
};

void __fastcall TOtaBrowseExpert::Execute()
{ try
  { TIDEServicesForm *f=new TIDEServicesForm(Application);
    f->s=BorlandIDEServices;
    f->ShowModal();
    delete f;
  }
  catch(...)
  { Application->MessageBox("An exception occurred in the expert","Error",MB_OK);
  }

}

//---------------------------------------------------------------------------


namespace Otabrowse5
{ void __fastcall PACKAGE Register()
  { RegisterPackageWizard(new TOtaBrowseExpert());
  }
}





// These are just some utility functions for this particular program.
// Not part of ToolsApiPlus.





AnsiString __fastcall BoolToString(bool b)
{ if (b) return "true"; else return "false";
}


AnsiString __fastcall VariantToString(Variant v,Typinfo::TTypeKind kind)
{ switch (kind)
  { case tkUnknown: return "_";
    case tkInteger: {int i=v; return AnsiString(i);}
    case tkChar: {char c=v; return AnsiString(c);}
    case tkEnumeration: {int i=v; return i;}
    case tkFloat: {float f=v; return AnsiString(f);}
    case tkString: {AnsiString s=v; return s;}
    case tkSet: return "_";
    case tkClass: return "_";
    case tkMethod: return "_";
    case tkWChar: return "_";
    case tkLString: {AnsiString ls=v; return ls;}
    case tkWString: {WideString ws=v; return AnsiString(ws);}
    case tkVariant: return "_";
    case tkArray: return "_";
    case tkRecord: return "_";
    case tkInterface: return "_";
    case tkInt64: return "_";
    case tkDynArray: return "_";
    default: return "_";
  }
}
AnsiString __fastcall KindToString(Typinfo::TTypeKind kind)
{ switch (kind)
  { case tkUnknown: return "tkUnknown";
    case tkInteger: return "tkInteger";
    case tkChar: return "tkChar";
    case tkEnumeration: return "tkEnumeration";
    case tkFloat: return "tkFloat";
    case tkString: return "tkString";
    case tkSet: return "tkSet";
    case tkClass: return "tkClass";
    case tkMethod: return "tkMethod";
    case tkWChar: return "tkWChar";
    case tkLString: return "tkLString";
    case tkWString: return "tkWString";
    case tkVariant: return "tkVariant";
    case tkArray: return "tkArray";
    case tkRecord: return "tkRecord";
    case tkInterface: return "tkInterface";
    case tkInt64: return "tkInt64";
    case tkDynArray: return "tkDynArray";
    default: return "tk???"+AnsiString((int)kind);
  }
}




AnsiString __fastcall ComponentToString(_di_IOTAFormEditor fe,_di_IOTAComponent c)
{ AnsiString name=GetComponentNameOTA(fe,c);
  AnsiString type=c->GetComponentType();
  AnsiString handle="@0x"+IntToHex((int)c->GetComponentHandle(),8);
  return name+":"+type+" "+handle;
}

AnsiString __fastcall PropertyTypeToString(Typinfo::TTypeKind tk)
{ switch (tk)
  { case tkUnknown: return "Unknown";
    case tkInteger: return "Integer";
    case tkChar: return "Char";
    case tkEnumeration: return "Enumeration";
    case tkFloat: return "Float";
    case tkString: return "String";
    case tkSet: return "Set";
    case tkClass: return "Class";
    case tkMethod: return "Method";
    case tkWChar: return "WChar";
    case tkLString: return "LString";
    case tkWString: return "WString";
    case tkVariant: return "Variant";
    case tkArray: return "Array";
    case tkRecord: return "Record";
    case tkInterface: return "Interface";
    default: return "???";
  }
}


char *buf=NULL;
char* __fastcall ResourceTypeFromString(AnsiString s)
{ if (s=="RT_RCDATA") return RT_RCDATA;
  if (s=="RT_DIALOG") return RT_DIALOG;
  if (s=="RT_FONT") return RT_FONT;
  if (s=="RT_FONTDIR") return RT_FONTDIR;
  if (s=="RT_MENU") return RT_MENU;
  if (s=="RT_STRING") return RT_STRING;
  if (s=="RT_MESSAGETABLE") return RT_MESSAGETABLE;
  if (s=="RT_CURSOR") return RT_CURSOR;
  if (s=="RT_GROUP_CURSOR") return RT_GROUP_CURSOR;
  if (s=="RT_BITMAP") return RT_BITMAP;
  if (s=="RT_ICON") return RT_ICON;
  if (s=="RT_GROUP_ICON") return RT_GROUP_ICON;
  if (s=="RT_VERSION") return RT_VERSION;
  if (s.SubString(1,1)=='\"' && s.SubString(s.Length(),1)=='\"')
  { AnsiString t=s.SubString(2,s.Length()-2);
    if (buf!=NULL) delete buf;
    buf=new char[t.Length()+1];
    strcpy(buf,t.c_str());
    return buf;
  }
  int i; try {i=s.ToInt();} catch (EConvertError &err) {return NULL;}
  return MAKEINTRESOURCE(i);
}
AnsiString __fastcall ResourceTypeToString(char *type)
{ if (type==RT_RCDATA) return "RT_RCDATA";
  if (type==RT_DIALOG) return "RT_DIALOG";
  if (type==RT_FONT) return "RT_FONT";
  if (type==RT_FONTDIR) return "RT_FONTDIR";
  if (type==RT_MENU) return "RT_MENU";
  if (type==RT_STRING) return "RT_STRING";
  if (type==RT_MESSAGETABLE) return "RT_MESSAGETABLE";
  if (type==RT_CURSOR) return "RT_CURSOR";
  if (type==RT_GROUP_CURSOR) return "RT_GROUP_CURSOR";
  if (type==RT_ICON) return "RT_ICON";
  if (type==RT_GROUP_ICON) return "RT_GROUP_ICON";
  if (type==RT_VERSION) return "RT_VERSION";
  if (type==RT_BITMAP) return "RT_BITMAP";
  DWORD d=(DWORD)type;
  if (HIWORD(d)==0) return AnsiString((int)d);
  // So it's just plain text. We'll do a little rigmarole to ensure that
  // we won't possible give an access violation trying to read it.
  char dst[MAX_PATH]; char *src=type; bool done=false; int lastchar;
  for (int i=0; i<MAX_PATH-1 && !done; i++) {dst[i]=src[i]; lastchar=i; if (src[i]==0 || IsBadReadPtr(src+i,1)) done=true;}
  dst[lastchar+1]=0; return "\""+AnsiString(dst)+"\"";
}

char *nbuf=NULL;
char* __fastcall ResourceNameFromString(AnsiString s)
{ if (s.SubString(1,1)=='\"' && s.SubString(s.Length(),1)=='\"')
  { AnsiString t=s.SubString(2,s.Length()-2);
    if (nbuf!=NULL) delete nbuf;
    nbuf=new char[t.Length()+1];
    strcpy(nbuf,t.c_str());
    return nbuf;
  }
  try
  { int i=s.ToInt(); return MAKEINTRESOURCE(i);
  }
  catch (EConvertError &err)
  { Application->MessageBox("Bad name. If you want a string name, enclose it in quotes.","Bad resource name",MB_OK);
    return NULL;
  }
}
AnsiString __fastcall ResourceNameToString(char *name)
{ DWORD d=(DWORD)name;
  if (HIWORD(d)==0) return AnsiString((int)d);
  char dst[MAX_PATH]; char *src=name; bool done=false; int lastchar;
  for (int i=0; i<MAX_PATH-1 && !done; i++) {dst[i]=src[i]; lastchar=i; if (src[i]==0 || IsBadReadPtr(src+i,1)) done=true;}
  dst[lastchar+1]=0; return "\""+AnsiString(dst)+"\"";
}




int __fastcall ShowModule(TComponent *Owner, _di_IOTAModule m)
{ TModuleForm *mf=new TModuleForm(Owner);
  mf->m=m; int res=mf->ShowModal(); delete mf; return res;
}

int __fastcall ShowModuleInfo(TComponent *Owner, _di_IOTAModuleInfo mi)
{ TModuleInfoForm *mif=new TModuleInfoForm(Owner);
  mif->mi=mi; int res=mif->ShowModal(); delete mif; return res;
}

int __fastcall ShowComponent(TComponent *Owner, _di_IOTAFormEditor fe, _di_IOTAComponent c)
{ TComponentForm *cf=new TComponentForm(Owner);
  cf->fe=fe; cf->c=c; int res=cf->ShowModal(); delete cf; return res;
}

int __fastcall ShowActionServices(TComponent *Owner, _di_IOTAActionServices as)
{ TActionServicesForm *asf=new TActionServicesForm(Owner);
  asf->as=as; int res=asf->ShowModal(); delete asf; return res;
}

int __fastcall ShowServices(TComponent *Owner, _di_IOTAServices s)
{ TServicesForm *sf=new TServicesForm(Owner);
  sf->s=s; int res=sf->ShowModal(); delete sf; return res;
}

int __fastcall ShowModuleServices(TComponent *Owner, _di_IOTAModuleServices ms)
{ TModuleServicesForm *msf=new TModuleServicesForm(Owner);
  msf->ms=ms; int res=msf->ShowModal(); delete msf; return res;
}

int __fastcall ShowDebuggerServices(TComponent *Owner, _di_IOTADebuggerServices ds)
{ TDebuggerServicesForm *dsf=new TDebuggerServicesForm(Owner);
  dsf->ds=ds; int res=dsf->ShowModal(); delete dsf; return res;
}

int __fastcall ShowPackageServices(TComponent *Owner,_di_IOTAPackageServices ps)
{ TPackageServicesForm *psf=new TPackageServicesForm(Owner);
  psf->ps=ps; int res=psf->ShowModal(); delete psf; return res;
}

int __fastcall ShowIDE(TComponent *Owner)
{ TIDEForm *idf=new TIDEForm(Owner);
  int res=idf->ShowModal(); delete idf; return res;
}

int __fastcall ShowProjectOptions(TComponent *Owner,_di_IOTAProjectOptions po)
{ TProjectOptionsForm *pof=new TProjectOptionsForm(Owner);
  pof->po=po; int res=pof->ShowModal(); delete pof; return res;
}

int __fastcall ShowMessageServices(TComponent *Owner,_di_IOTAMessageServices40 ms)
{ TMessageServicesForm *msf=new TMessageServicesForm(Owner);
  msf->ms=ms; int res=msf->ShowModal(); delete msf; return res;
}


void __fastcall ShowWatcherServices()
{ TWatcherServicesForm *wsf=new TWatcherServicesForm(Application); wsf->Show();
}



void __fastcall ShowProjectNotifier(_di_IOTAServices s)
{ TNotifierForm *nf=new TNotifierForm(Application); nf->Show();
  nf->StartServices(s);
}
void __fastcall ShowModuleNotifier(_di_IOTAModule m)
{ TNotifierForm *nf=new TNotifierForm(Application); nf->Show();
  nf->StartModule(m);
}
void __fastcall ShowFormNotifier(_di_IOTAFormEditor fe)
{ TNotifierForm *nf=new TNotifierForm(Application); nf->Show();
  nf->StartForm(fe);
}

void __fastcall ShowDebuggerNotifier(_di_IOTADebuggerServices ds)
{ TNotifierForm *nf=new TNotifierForm(Application); nf->Show();
  nf->StartDebugger(ds);
}

int __fastcall ShowEditor(TComponent *Owner, _di_IOTAEditor e)
{ _di_IOTAProjectResource re=NULL;
  _di_IOTAFormEditor fe=NULL;
  _di_IOTASourceEditor se=NULL;
  _di_IOTATypeLibEditor te=NULL;
  HRESULT reres=e->QueryInterface(__uuidof(IOTAProjectResource),(void**)&re);
  HRESULT feres=e->QueryInterface(__uuidof(IOTAFormEditor),(void**)&fe);
  //HRESULT seres=e->QueryInterface(__uuidof(IOTASourceEditor),(void**)&se);
  //HRESULT teres=e->QueryInterface(__uuidof(IOTATypeLibEditor),(void**)&te);
  if (SUCCEEDED(reres))
  { TResourceEditorForm *ref=new TResourceEditorForm(Owner);
    ref->pr=re; int res=ref->ShowModal(); delete ref; return res;
  }
  else if (SUCCEEDED(feres))
  { TFormEditorForm *fef=new TFormEditorForm(Owner);
    fef->fe=fe; int res=fef->ShowModal(); delete fef; return res;
  }
  else
  { TEditorForm *ef=new TEditorForm(Owner);
    ef->e=e; int res=ef->ShowModal(); delete ef; return res;
  }
}

int __fastcall ShowResourceEntry(TComponent *Owner, _di_IOTAResourceEntry re)
{ TResourceEntryForm *ref=new TResourceEntryForm(Owner);
  ref->re=re;
  int res=ref->ShowModal();
  delete ref;
  return res;
}

